from network_esp32 import wifi
from simple import MQTTClient
from machine import Timer
import _thread
import sensor
import lcd

from maix import nn
from PIL import Image, ImageDraw, ImageFont

import time
from maix.nn import decoder

def camera_init():
  sensor.reset()
  sensor.set_pixformat(sensor.RGB565)
  sensor.set_framesize(sensor.QVGA)
  sensor.skip_frames(10)
  sensor.run(1)

red_threshold =  (55, 70, 42, 65, 52, 8)
orange_threshold =(0, 80, 66, -20, 80, 50)
green_threshold =   (0, 88, -42, -6, -9, 13)
global  msg,topic

# 自定义函数
def wifi_mqttChuShiHua():
  while not (wifi.isconnected()):
    pass
def SheXiangTouPingMuChuShiHua():
  lcd.init(freq=15000000, color=65535, invert=0)
  camera_init()
def ChuShiHua():
  SheXiangTouPingMuChuShiHua()
def RenLianShiBie():
  pass
  def draw_rectangle_with_title(draw, box, disp_str, bg_color=(255, 0, 0, 255), font_color=(255, 255, 255, 255)):
      # draw = ImageDraw.Draw(img)
      font = ImageFont.load_default()

      font_w, font_h = font.getsize(disp_str)
      draw.rectangle((box[0], box[1], box[0] + box[2], box[1] + box[3]), fill=None, outline=bg_color, width=2)
      draw.rectangle((box[0], box[1] - font_h, box[0] + font_w, box[1]), fill=bg_color)
      draw.text((box[0], box[1] - font_h), disp_str, fill=font_color, font=font)
def face():
    img = camera.capture()
    if not img:
        time.sleep(0.01)
        continue
    t = time.time()
    out = m.forward(img, quantize=True, layout="hwc")
    print("-- forward: ", time.time() - t )

    t = time.time()
    boxes, probs = yolo2_decoder.run(out, nms=0.3, threshold=0.5, img_size=(240, 240))
    print("-- decode: ", time.time() - t )

    t = time.time()
    for i, box in enumerate(boxes):
        class_id = probs[i][0]
        prob = probs[i][1][class_id]
        disp_str = "{}:{:.2f}%".format(labels[class_id], prob*100)
        draw_rectangle_with_title(display.get_draw(), box, disp_str)
    print("-- draw: ", time.time() - t )
def shop_run():
    img = sensor.snapshot()
    blobs = img.find_blobs([orange_threshold],roi=[0,0,320,240],area_threshold=200,pixels_threshold=200,merge=1,margin=10)
    if bool(blobs):
      for i in blobs:
        img = img.draw_rectangle(i[0:4],(0,0,255),1,0)
        img = img.draw_cross(i[5],i[6])
        lcd.draw_string(i[5], i[6], str("fen da"), 0, 65535)
        time.sleep_ms(50)
    else
        mqtt.publish1( "WZ4Rra7ng","芬达缺货 请补货")
    blobs1 = img.find_blobs([red_threshold],roi=[0,0,320,240],area_threshold=200,pixels_threshold=200,merge=1,margin=10)
    if bool(blobs1):
      for i1 in blobs1:
          img = img.draw_rectangle(i1[0:4],(255,0,0),1,0)
          img = img.draw_cross(i1[5],i1[6])
          lcd.draw_string(i1[5], i1[6], str("xue bi"), 0, 65535)
          time.sleep_ms(50)
    else
          mqtt.publish1( "WZ4Rra7ng","雪碧缺货 请补货")
    blobs2 = img.find_blobs([green_threshold],roi=[0,0,320,240],area_threshold=200,pixels_threshold=200,merge=1,margin=10)
    if bool(blobs2):
      for i2 in blobs2:
          img = img.draw_rectangle(i2[0:4],(0,255,0),1,0)
          img = img.draw_cross(i2[5],i2[6])
          lcd.draw_string(i2[5], i2[6], str("ke le"), 0, 65535)
          time.sleep_ms(50)
     else
          mqtt.publish1( "WZ4Rra7ng","可乐缺货 请补货")
    lcd.display(img)
def warm（）:
    if ( 26< dht11_8.temperature()):
       mqtt.publish1( "12-cfCnng","温度过高")
    if (Pin.digital_read(board_info.PIN2==1):
        mqtt.publish1( "12-cfCnng","火灾报警")
    if (Pin.digital_read(board_info.PIN5==1):
        mqtt.publish1( "12-cfCnng","有人求助")
t = time.time()
display.show()
print("-- show: ", time.time() - t )

# 事件回调函数
def thread_2():
  wifi_mqttChuShiHua()
  mqtt.publish1( "WZ4Rra7ng","init_over")
  while True:
    mqtt.wait_msg()
def mqtt_callback(_topic,_msg):
  topic = _topic.decode('utf-8', 'ignore')
  msg = _msg.decode('utf-8', 'ignore')
  if (msg.find("123")!=-1):
    mqtt.publish1( "WZ4Rra7ng","get")


if wifi.isconnected() == False:
    for i in range(5):
        try:
            wifi.reset(is_hard=True)
            print('try AT connect wifi...')
            wifi.connect("123456", "zhaoxinrong")
            if wifi.isconnected():
                break
        except Exception as e:
            print(e)

mqtt = MQTTClient("0805e3d04f3b34e8", "182.254.130.180", 1883, "L1Q3uan7R", "L1w3X-n7Rz", keepalive=0)
try:
    mqtt.connect()
    print('Connected')
except:
    print('Disconnected')
_thread.start_new_thread(thread_2, ())
mqtt.set_callback(mqtt_callback)
ChuShiHua()
mqtt.subscribe("WZ4Rra7ng")
def timer_tick(_):
        mqtt.ping()
tim = Timer(Timer.TIMER0, Timer.CHANNEL0, mode=Timer.MODE_PERIODIC, period=1, unit=Timer.UNIT_S, callback=timer_tick, arg=None, start=False, priority=1, div=0)
model = {
    "param": "/root/models/yolo2_face_awnn.param",
    "bin": "/root/models/yolo2_face_awnn.bin"
}

options = {
    "model_type":  "awnn",
    "inputs": {
        "input0": (224, 224, 3)
    },
    "outputs": {
        "output0": (7, 7, (1+4+1)*5)
    },
    "mean": [127.5, 127.5, 127.5],
    "norm": [0.0078125, 0.0078125, 0.0078125],
}
print("-- load model:", model)
m = nn.load(model, opt=options)
print("-- load ok")

print("-- read image")
w = options["inputs"]["input0"][1]
h = options["inputs"]["input0"][0]
# # img.show()
print("-- read image ok")


labels = ["person"]
anchors = [1.19, 1.98, 2.79, 4.59, 4.53, 8.92, 8.06, 5.29, 10.32, 10.65]
yolo2_decoder = decoder.Yolo2(len(labels), anchors, net_in_size=(w, h), net_out_size=(7, 7))
person = 0
while True:
  if face()==1:
    servo.angle(board_info.PIN3, 1, 90)
    time.sleep(2)
    servo.angle(board_info.PIN2, 1, 170)
    mqtt.publish1( "XjeYrLnnR","lmy enter")
    mqtt.publish1( "UEWKfj77g","door open")
    if mode ==1:
        mqtt.publish1( "XjeYrLnnR",person+1)
    else if mode == 2
        mqtt.publish1( "XjeYrLnnR",person-1)
    if face()==2:
      servo.angle(board_info.PIN3, 1, 90)
      time.sleep(2)
      servo.angle(board_info.PIN2, 1, 170)
      mqtt.publish1( "XjeYrLnnR","zxr enter")
      mqtt.publish1( "UEWKfj77g","door open")
      if mode ==1:
          mqtt.publish1( "XjeYrLnnR",person+1)
      else if mode == 2
          mqtt.publish1( "XjeYrLnnR",person-1)
    shop_run()
    warm（）
